<?php
/**
 * TorrentTrader Lite v2.0.1 
 *  - Coded by Sqrtboy 
 *  - Released under the GPL licence
 *  - Contact/Support/Hacks/Discussion @ http://www.phpsoft.org
 **/


  ob_start('ob_gzhandler');
  require_once("functions.php");

  $info_hash = (string)$_GET['info_hash'];
  $mode = (string)$_GET['mode'];
  
  if ($mode == "details")
  $info_hash = substr($info_hash, 2);

  if (strlen($info_hash) != 40 || !file_exists('torrents/'.$info_hash.'.torrent') || file_exists('data/'.$info_hash.'.lock'))
  {
  // invalid info_hash format was given or torrent is banned
  header("Location: index.php");
  exit();
  }
  else
  {

		if ($mode != "details")
		{
			  // seeders table
			$seeders_display .=
			'<table align="center" cellpadding="0" cellspacing="0" style="border-collapse: collapse;border-color:#646262" width="100%" border="1"><tr>
			<td>
			<table align="center" cellpadding="0" cellspacing="0" style="border-collapse: collapse;border-color:#D6D9DB" width="100%" border="1">
			<tr>
			<td bgcolor="#8cb5f6" align="center" width="20%">'.DETAILS_IP.'</td>
			<td bgcolor="#8cb5f6" align="center" width="10%">'.DETAILS_PORT.'</td>
			<td bgcolor="#8cb5f6" align="center" width="20%">'.DETAILS_UL.'</td>
			<td bgcolor="#8cb5f6" align="center" width="20%">'.DETAILS_DL.'</td>
			<td bgcolor="#8cb5f6" align="center" width="15%">'.DETAILS_LEFT.'</td>
			<td bgcolor="#8cb5f6" align="center" width="15%">'.DETAILS_IDLE.'</td>
			</tr>';
	
			// leechers table
			$leechers_display .=
			'<table align="center" cellpadding="0" cellspacing="0" style="border-collapse: collapse;border-color:#646262" width="100%" border="1"><tr>
			<td>
			<table align="center" cellpadding="0" cellspacing="0" style="border-collapse: collapse;border-color:#D6D9DB" width="100%" border="1">
			<tr>
			<td bgcolor="#8cb5f6" align="center" width="20%">'.DETAILS_IP.'</td>
			<td bgcolor="#8cb5f6" align="center" width="10%">'.DETAILS_PORT.'</td>
			<td bgcolor="#8cb5f6" align="center" width="20%">'.DETAILS_UL.'</td>
			<td bgcolor="#8cb5f6" align="center" width="20%">'.DETAILS_DL.'</td>
			<td bgcolor="#8cb5f6" align="center" width="15%">'.DETAILS_LEFT.'</td>
			<td bgcolor="#8cb5f6" align="center" width="15%">'.DETAILS_IDLE.'</td>
			</tr>';
	
			// we create it if doesn't exist already
			$result = getstat($info_hash);

			$count_s = 0;
			$count_l = 0;
			
			if (!empty($result['complete']))
			{
				foreach ($result['complete'] as $info)
				{
						$seeders_display .=
						'<tr>
							<td align="center" width="20%">'.preg_replace('/\.\d+$/', ".xxx", $info['ip']).'</td>
							<td align="center" width="10%">'.$info['port'].'</td>
							<td align="center" width="20%"><font color="green">'.tt_filesize($info['uploaded']).'</font></td>
							<td align="center" width="20%"><font color="blue">'.tt_filesize($info['downloaded']).'</font></td>
							<td align="center" width="15%">'.tt_filesize($info['left']).'</td>
							<td align="center" width="15%">'.($info['time']).' min</td>
						</tr>';
						$count_s += 1;		
				}
				$seeders_display .="</table></td></tr></table>";
			}
			else
			{
				// no seeder found	
						
				$seeders_display .= '<tr><td align="center" colspan="8"><br />
				<table border="0" width="500" cellspacing="0" cellpadding="0"><tr>
				<td bgcolor="#FFFFFF" align="center" style="border-style: dotted; border-width: 1px; border-color:red">
				<font face="Verdana" size="1">'.DETAILS_NO_SEEDERS.'</font></td>
				</tr></table><br /></td></tr></table></td></tr></table>';
			}
	


			if (!empty($result['incomplete']))
			{
				foreach ($result['incomplete'] as $info)
				{
						$leechers_display .=
						'<tr>
							<td align="center" width="20%">'.preg_replace('/\.\d+$/', ".xxx", $info['ip']).'</td>
							<td align="center" width="10%">'.$info['port'].'</td>
							<td align="center" width="20%"><font color="green">'.tt_filesize($info['uploaded']).'</font></td>
							<td align="center" width="20%"><font color="blue">'.tt_filesize($info['downloaded']).'</font></td>
							<td align="center" width="15%">'.tt_filesize($info['left']).'</td>
							<td align="center" width="15%">'.($info['time']).' min</td>
						</tr>';
						$count_l += 1;		
				}
				$leechers_display .="</table></td></tr></table>";
			}
			else
			{		
				// no leecher found

				$leechers_display .= '<tr><td align="center" colspan="8"><br />
					<table border="0" width="500" cellspacing="0" cellpadding="0"><tr>
					<td bgcolor="#FFFFFF" align="center" style="border-style: dotted; border-width: 1px;border-color:red">
					<font face="Verdana" size="1">'.DETAILS_NO_LEECHERS.'</font></td>
					</tr></table><br /></td></tr></table></td></tr></table>';
			}
	

		
		}
		

        // we check if the info_hash exists in our database
        $source = fopen('data/torrents.dat','r+');
        flock($source, LOCK_EX) ;
        $found = 0 ;
        while ($info = fscanf ($source, "%s %s %s %ld %d %s %s %d %d %d %d\n")) {
        list ($prev_info_hash, $filename, $name,$size,$numfiles,$descr,$category,$seeders,$leechers,$completed,$hits) = $info;

         if ($info_hash ==  $prev_info_hash)
          {
            // found it
            $row['name']  = $name;
            $row['filename'] = $filename;
            $row['seeders']  = $seeders;
            $row['leechers'] = $leechers;
            $row['completed']  = $completed;
            $row['hits']  = $hits;
            $row['size']  = $size;
            $row['numfiles']  = $numfiles;
            $row['descr']  = $descr;
            $row['category']  = $category;
            $found += 1;
            $content .= sprintf("%s %s %s %ld %d %s %s %d %d %d %d\n",$prev_info_hash, $filename, $name,$size,$numfiles,$descr,$category,$count_s,$count_l,$completed,$hits);
         }
         else
         $content .= sprintf("%s %s %s %ld %d %s %s %d %d %d %d\n",$prev_info_hash, $filename, $name,$size,$numfiles,$descr,$category,$seeders,$leechers,$completed,$hits);
        }
        rewind($source);
        ftruncate($source,0);
        fwrite($source,$content);
        flock($source, LOCK_UN);
        fclose($source);

        if ($found == 0)
        {
        //  not found it
        header("Location: index.php");
        exit();
        }


		if ($mode != "details")
		{
			if ($mode != "ajax")
			site_header();
			
			$row['seeders']  = $count_s;
            $row['leechers'] = $count_l;
	
			// now we can post some content on the site
			$content = '<center>
			<a href="'.(($ajax_browse == "yes") ? "javascript:sndAjaxReq('index');" : "index.php").'"><strong>'.DETAILS_RETURN.'</strong></a><br /><br />
			<table align="left" width="100%" border="0" cellspacing="0" cellpadding="3">
					 <tr>
						<td><strong>'.DETAILS_NAME.'</strong></td>
						<td>'.$row['name'].'</td>
					</tr>
					<tr>
						<td><strong>'.DETAILS_HASH.'</strong></td>
						<td>'.$info_hash.'</td>
					</tr>
					<tr>
						<td><strong>'.DETAILS_FILENAME.'</strong></td>
						<td>'.$row['filename'].'</td>
					</tr>
					<tr>
						<td><strong>'.DETAILS_DOWNLOAD.'</strong></td>
						<td><a href="download.php?action=torrent&amp;info_hash='.$info_hash.'"> &nbsp;<img src="images/download.gif" border="0" alt="Download" />&nbsp;'.DETAILS_DOWNLOAD_NOW.'</a> <br />
						<a href="magnet:?xt=urn:btih:'. strtoupper(base32_encode(pack('H*',$info_hash))).'"> &nbsp;<img src="images/download.gif" border="0" alt="Download" />&nbsp;'.DETAILS_MAGNET_LINK.'</a>
						<br />
						<a href="dht://'. strtoupper($info_hash).'.dht"> &nbsp;<img src="images/download.gif" border="0" alt="Download" />&nbsp;'.DETAILS_DHT_LINK.'</a></td>
					</tr>';
			if (file_exists("torrents/".$info_hash.".nfo"))
			{
					$content .=
					'<tr>
						<td><strong>'.DETAILS_NFO_DOWNLOAD.'</strong></td>
						<td><a href="download.php?action=nfo&amp;info_hash='.$info_hash.'">'.DETAILS_NFO_DOWNLOAD_NOW.'</a></td>
					</tr>';
			}
	
			if (file_exists("torrents/".$info_hash.".jpg"))
			{
					$content .=
					'<tr>
						<td><strong>'.DETAILS_IMG_DOWNLOAD.'</strong></td>
						<td><a href="download.php?action=image&amp;info_hash='.$info_hash.'">'.DETAILS_IMG_DOWNLOAD_NOW.'</a></td>
					</tr>';
			}
	
			$content .=
					'<tr>
						<td><strong>'.DETAILS_STATUS.'</strong></td>
						<td><font color="green"><b>'.$row['seeders'].'</b></font> '.DETAILS_SEEDERS.' , <font color="blue"><b>'.$row['leechers'].'</b></font> '.DETAILS_LEECHERS.' , '.DETAILS_COMPLETED.' <b>'.$row['completed'].'</b> '.DETAILS_TIMES.'</td>
					</tr>
					<tr>
						<td><strong>'.DETAILS_HITS.'</strong></td>
						<td>'.$row['hits'].'</td>
					</tr>
					<tr>
						<td><strong>'.DETAILS_SIZE.'</strong></td>
						<td>'.tt_filesize($row['size']).'</td>
					</tr>
					<tr>
						<td><strong>'.DETAILS_NUMBEROFFILES.'</strong></td>
						<td>'.$row['numfiles'].'</td>
					</tr>
					<tr>
						<td><strong>'.DETAILS_DESCRIPTION.'</strong></td>
						<td>'.str_replace("_"," ",$row['descr']).'</td>
					</tr>
					<tr>
						<td><strong>'.DETAILS_CATEGORY.'</strong></td>
						<td>'.$row['category'].'</td>
					</tr>
					<tr>
						<td><strong>'.DETAILS_SEEDS.'</strong></td>
						<td>'.$seeders_display.'</td>
					</tr>
					<tr>
						<td><strong>'.DETAILS_LEECHS.'</strong></td>
						<td>'.$leechers_display.'</td>
					</tr>
	
			</table> ';
	
			main_box($row['name'],$content.'<br /><br /><a href="'.(($ajax_browse == "yes") ? "javascript:sndAjaxReq('index');" : "index.php").'"><strong>'.DETAILS_RETURN.'</strong></a></center>');
		}
		else
		{
		
					$content = '
			<table   border="1" cellspacing="0" cellpadding="3">
					<tr>
						<td colspan="2" bgcolor="#8cb5f6" align="center"><strong>'.DETAILS_SUMMARY.'</strong></td>
						
					</tr>			
					<tr>
						<td><strong>'.DETAILS_HASH.'</strong></td>
						<td>'.$info_hash.'</td>
					</tr>
					<tr>
						<td><strong>'.DETAILS_FILENAME.'</strong></td>
						<td>'.$row['filename'].'</td>
					</tr>
					<tr>
						<td><strong>'.DETAILS_DOWNLOAD.'</strong></td>
						<td><a href="download.php?action=torrent&amp;info_hash='.$info_hash.'">&nbsp;<img src="images/download.gif" border="0" alt="Download" /> '.DETAILS_DOWNLOAD_NOW.'</a>
						 <br />
						<a href="magnet:?xt=urn:btih:'. strtoupper(base32_encode(pack('H*',$info_hash))).'"> &nbsp;<img src="images/download.gif" border="0" alt="Download" />&nbsp;'.DETAILS_MAGNET_LINK.'</a>
						<br />
						<a href="dht://'. strtoupper($info_hash).'.dht"> &nbsp;<img src="images/download.gif" border="0" alt="Download" />&nbsp;'.DETAILS_DHT_LINK.'</a></td>
					</tr>';
			if (file_exists("torrents/".$info_hash.".nfo"))
			{
					$content .=
					'<tr>
						<td><strong>'.DETAILS_NFO_DOWNLOAD.'</strong></td>
						<td><a href="download.php?action=nfo&amp;info_hash='.$info_hash.'">'.DETAILS_NFO_DOWNLOAD_NOW.'</a></td>
					</tr>';
			}
	
			if (file_exists("torrents/".$info_hash.".jpg"))
			{
					$content .=
					'<tr>
						<td><strong>'.DETAILS_IMG_DOWNLOAD.'</strong></td>
						<td><a href="download.php?action=image&amp;info_hash='.$info_hash.'">'.DETAILS_IMG_DOWNLOAD_NOW.'</a></td>
					</tr>';
			}
	
			$content .=
					'<tr>
						<td><strong>'.DETAILS_STATUS.'</strong></td>
						<td><font color="green"><b>'.$row['seeders'].'</b></font> '.DETAILS_SEEDERS.' , <font color="blue"><b>'.$row['leechers'].'</b></font> '.DETAILS_LEECHERS.' , '.DETAILS_COMPLETED.' <b>'.$row['completed'].'</b> '.DETAILS_TIMES.'</td>
					</tr>
					<tr>
						<td><strong>'.DETAILS_HITS.'</strong></td>
						<td>'.$row['hits'].'</td>
					</tr>
					<tr>
						<td><strong>'.DETAILS_SIZE.'</strong></td>
						<td>'.tt_filesize($row['size']).'</td>
					</tr>
					<tr>
						<td><strong>'.DETAILS_NUMBEROFFILES.'</strong></td>
						<td>'.$row['numfiles'].'</td>
					</tr>
					<tr>
						<td><strong>'.DETAILS_DESCRIPTION.'</strong></td>
						<td>'.str_replace("_"," ",$row['descr']).'</td>
					</tr>
	
			</table> ';
		
		echo "i_".$info_hash."|".$content;
		exit;	
		}

  }

  if ($mode != "ajax")
  site_footer();
?>